
#include<P24FXXXX.h>
#include<stdio.h>

//	*********************************************************************************************************************
//	Two Speed Start-up Disable & HS oscillator & Primary oscillator (XT, HS, EC) & both Clock switching and clock monitor
//	*********************************************************************************************************************
	_CONFIG2(IESO_OFF & POSCMOD_HS & FNOSC_PRI& FCKSM_CSDCMD )
	_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & ICS_PGx1 & FWDTEN_OFF & WINDIS_OFF )

void	PMP_Initial(void);
void	ADC_Initial(void);
void	AD_Delay(void);
void	UART1_Initial(void);


#define		INPUT 		1
#define		OUTPUT		0

#define		LED0		LATDbits.LATD0
#define		Ctrl_U1RX 	TRISFbits.TRISF2 
#define		Ctrl_U1TX 	TRISFbits.TRISF3 

unsigned int	ADC_TempValue ; 
unsigned char 	ASCII_Buffer[10] ;
int				TempValue1 , TempValue2 , TempValue3 , TempValue4 , TempValue5;

int main(void) 
{
	int	LoopVar1 ;

		ADC_Initial() ;
		PMP_Initial();
		AD1PCFGbits.PCFG15 = 1 ;		// RB15(AN15) shared with PMPA0
		LCD_Initial() ;

	LED0 = 0 ;	
	TRISDbits.TRISD0 = 0;

	putrsLCD("I am APP026-3") ;

		LCD_SetCursor(0,1) ;
		putrsLCD("ADC=") ;

	while(1)
	{
		LED0 = !LED0 ;

		//	Convert ADC			
		AD1CHS = 0x0002 ;				//	Convert AN2 
		AD_Delay() ;
		AD1CON1bits.SAMP = 0 ;			//	Start Conversion 
		Nop() ;
		Nop() ;
		while ( ! AD1CON1bits.DONE ) ;

		ADC_TempValue = ADC1BUF0 ;
		My_itoa(ADC_TempValue,ASCII_Buffer) ;

		LCD_SetCursor(5,1) ;
		putrsLCD("        ") ;		
		LCD_SetCursor(5,1) ;
		putsLCD(ASCII_Buffer) ;

		printf ( " Hello ! ڬO dsPIC24FJ128GA006 \n\r" ) ;


		for (LoopVar1 = 0 ; LoopVar1 < 30000 ; LoopVar1 ++) ;
		for (LoopVar1 = 0 ; LoopVar1 < 30000 ; LoopVar1 ++) ;
		for (LoopVar1 = 0 ; LoopVar1 < 30000 ; LoopVar1 ++) ;
		for (LoopVar1 = 0 ; LoopVar1 < 30000 ; LoopVar1 ++) ;
	}
}

void	UART1_Initial(void)
{

		U1MODE = 0x8800 ;
		U1STA = 0x2400 ;
		U1BRG =101 ;				// Baud-Rate = 4800 when Fcy = 16M , BRGH = 0 

		Ctrl_U1RX = INPUT ;
		Ctrl_U1TX = OUTPUT ;

/*    -----------------------------------------------------------------------------------------------------------------------------------------------------				
		config1 = 	UART_EN & UART_IDLE_CON \
				   	& UART_DIS_WAKE & UART_DIS_LOOPBACK \
					& UART_DIS_ABAUD & UART_NO_PAR_8BIT & UART_1STOPBIT ;
		config2 = 	UART_INT_TX & UART_TX_PIN_NORMAL & UART_TX_ENABLE 
					& UART_INT_RX_CHAR & UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR ;

		OpenUART1 ( config1 , config2 , 0xa2 ) ;
	-------------------------------------------------------------------------------------------------------------------------------------------------------*/

	
}

void	My_itoa(unsigned int IntValue , unsigned char *TheString)
{

		int	ZeroFill ;

		ZeroFill = 0 ;		

		TempValue1 = IntValue/10000 ;
		TempValue2 = (IntValue-(TempValue1*10000))/1000 ;
		TempValue3 = (IntValue-(TempValue1*10000)-(TempValue2*1000))/100 ;
		TempValue4 = (IntValue-(TempValue1*10000)-(TempValue2*1000)- (TempValue3*100))/10 ;
		TempValue5 = IntValue % 10 ;

		if (TempValue1 != 0 )
			{
				*TheString++ = TempValue1 + '0' ;
				ZeroFill = 1 ;
			}
		if (TempValue2 != 0 || ZeroFill  )
			{
				*TheString++ = TempValue2 + '0' ;
				ZeroFill = 1 ;
			}
		if (TempValue3 != 0 || ZeroFill ) 
			{
				*TheString++ = TempValue3 + '0' ;
				ZeroFill = 1 ;
			}
		if (TempValue4 != 0 || ZeroFill )
			{
				*TheString++ = TempValue4 + '0' ;
				ZeroFill = 1 ;
			}
			*TheString++ = TempValue5 + '0' ;
			*TheString = 0x00 ;				//	End of string !!	

}

void	AD_Delay(void)
{
		int	LoopVar ;
		int	LoopVar2 , LoopVar3 ;
		
		for ( LoopVar = 0 ; LoopVar < 100 ; LoopVar++ )
			LoopVar2 = LoopVar3 + 1 ;
		
}

void	ADC_Initial(void)
{
		AD1CON1 = 0b0000000000000110 ;	// 	Mode : 	Clear SAMP start conversion
										//		   	ASAM = 1 --> SAMP auto set 
		AD1CON2 = 0b0000000000000000 ;
		AD1CON3 = 0b1000001100001111 ;	//	Internal RC as AD Clock 
		AD1CHS = 0x00 ;					//  Use AN0 temporary 
		AD1PCFG = 0b1111111111111011 ;	// 	AN2 enabled
		AD1CON1bits.ADON = 1 ;
}

void	PMP_Initial(void)
{
			//********************************************************************************
			//  STEP 1:
			//	Configure PMPCON: PMP on, address/data not multiplexed, PMPBE active high, 
			//	PMPWR I/O, PMPRD I/O, 8-bit data, PMPENB and PMPRD/~PMPWR active high.
			//********************************************************************************/
			PMCON = 0b1000001100000111;


			//********************************************************************************
			//	STEP 2:
			//	Configure PMPMODE: Interrupts, stall, buffers, inc/dec off, 8 bit mode,
			//	combined read/write with byte enable signals, and max the 3 wait delays.
			//********************************************************************************/
			PMMODE = 0x3FF;

			//********************************************************************************
			//	STEP 3:	
			//	Configure PMPEN: Enable A0 function to control RS and disable all other 
			//	PMP address pins.
			//********************************************************************************/
			PMAEN = 0x0001;

			//********************************************************************************
			// 	STEP 4:
			//	Configure PMPADDR: A0 selects type of instruction, either command or data.
			//	This is a command so A0 should be low.
			//********************************************************************************/
			PMADDR = 0x0000;
}


